@echo off
cls
set savestamp=%DATE:/=-%@%TIME::=-%
set directory=%0
set folder=%~dp0
set logfile="%folder%log_%savestamp%.txt"
set folder=%~dp0
SetLocal EnableDelayedExpansion 

REM @echo "======================================================="
REM @echo "             Setting Environment Variables             "
REM @echo "======================================================="
REM ##	Set variables used for the script
REM ##	Variables for MTU Testing
set MTU="1300"
set increment="1"
set maxmtu="1500"

REM ##	Variables for iPerf Speed Testing
set pingcount=30
set iperftime=30

REM ##	Generic Variables used throughout the tool
set trace-svr-ext=8.8.8.8
set trace-svr-int=speedtest.mhn.cloud
set iperf-svr=speedtest.mhn.cloud

REM ##	Set variable to run iPerf3
set iperf3path="%folder%iperf3.exe"


REM ##	Variables for Description, Location, Connection Type, etc
set description="%hostname% WAN Connection Test"

REM ## Set Console Size
mode con: cols=56 lines=37
COLOR 1F

@echo =======================================================
@echo   Hosted Network Speed and Connectivity Testing tool  
@echo                 Tool Version: 1.0.5                   
@echo =======================================================
@echo.
@echo =======================================================
@echo                Running Diagnostics Tests              
@echo       This may take up to 5 minutes to complete       
@echo =======================================================

REM Displaying Menu

@echo.
@echo =======================================================
@echo    Please select your state from the options below
@echo =======================================================
@echo.
@echo 1 - New South Wales
@echo 2 - Victoria
@echo 3 - Queensland
@echo 4 - Northern Territory
@echo 5 - South Australia
@echo 6 - Western Australia
@echo 7 - Tasmania
@echo.
@echo =======================================================
@echo.
SET /P M=Select the option above and press enter:

IF %M%==1 set iperf-svr=speedtest.mhn.cloud
IF %M%==2 set iperf-svr=speedtest.vic.mhn.cloud
IF %M%==3 set iperf-svr=speedtest.qld.mhn.cloud
IF %M%==4 set iperf-svr=speedtest.qld.mhn.cloud
IF %M%==5 set iperf-svr=speedtest.vic.mhn.cloud
IF %M%==6 set iperf-svr=speedtest.wa.mhn.cloud
IF %M%==7 set iperf-svr=speedtest.vic.mhn.cloud

IF %M%==1 echo Selected State: New South Wales >> %logfile%
IF %M%==2 echo Selected State: Victoria >> %logfile%
IF %M%==3 echo Selected State: Queensland >> %logfile%
IF %M%==4 echo Selected State: Northern Territory >> %logfile%
IF %M%==5 echo Selected State: South Australia >> %logfile%
IF %M%==6 echo Selected State: Western Australia >> %logfile%
IF %M%==7 echo Selected State: Tasmania >> %logfile%


REM ##	Checking if .exe files exist

REM ##	Starting Diagnostics
REM ##	Adding the WAN IP of the connection to the Log File
@echo. >> %logfile%
@echo Connection WAN IP: >> %logfile%
FOR /F "SKIP=4 TOKENS=2" %%a IN ('"NSLOOKUP myip.opendns.com resolver1.opendns.com 2>NUL"') DO ECHO %%a >> %logfile%
@echo.>> %logfile%
@echo.
@echo =======================================================
@echo = Step 1/4 ====================== Running iPerf Tests = 
@echo =======================================================
	REM ## Reason this is here twice is so that it appears in the logs
	@echo = Step 1/4 ====================== Running iPerf Tests =  >> %logfile%
	@echo. >> %logfile%
	@echo ==================== iPerf Upload ===================== >> %logfile%
	%iperf3path% -c %iperf-svr% -t 30 -P 8 >> %logfile% 
	@echo =================== iPerf Download ==================== >> %logfile%
	@echo. >> %logfile%
	%iperf3path% -c %iperf-svr% -t 30 -R -P 8 >> %logfile%




@echo.
@echo =======================================================
@echo = Step 2/4 ======================= Running MTU Checks =
@echo =======================================================
REM ## Reason this is here twice is so that it appears in the logs
	@echo = Step 2/4 ======================= Running MTU Checks = >> %logfile%
	@echo. >> %logfile%
	@echo =================== MTU to External =================== >> %logfile%
	:seek
	ping -n 1 -l !MTU! -f -4 !trace-svr-ext! 1>nul
	if !ERRORLEVEL! EQU 0 (
	  set /A MTU=!MTU!
	  set /A "MTU=(!MTU! + !increment!)"
	  if !MTU! NEQ !maxmtu! goto :seek)
	ping -n 1 -l !MTU! -f -4 !trace-svr-ext! >> %logfile%
	set mtu-result=!MTU!
	set /a mtu-=8
	@echo External MTU to "%trace-svr-ext%" is between %mtu% and %mtu-result% >>%logfile%
	@echo. >> %logfile%
	@echo =================== MTU to Internal =================== >> %logfile%
	REM ## Reset MTU
	set mtu=1300

	REM ##	Run Internal MTU Tests
	:seek1
	ping -n 1 -l !MTU! -f -4 !iperf-svr! 1>nul
	if !ERRORLEVEL! EQU 0 (
	  set /A MTU=!MTU!
	  set /A "MTU=(!MTU! + !increment!)"
	  if !MTU! NEQ !maxmtu! goto :seek1)
	ping -n 1 -l !MTU! -f -4 !iperf-svr! >> %logfile%
	set mtu-result=!MTU!
	set /a mtu-=8
	@echo Internal MTU to "%iperf-svr%" is between %mtu% and %mtu-result% >> %logfile%
	
	
	
@echo.
@echo =======================================================
@echo = Step 3/4 ================ Running Packet Loss Check =
@echo =======================================================
	REM ## Reason this is here twice is so that it appears in the logs
	@echo = Step 3/4 ================ Running Packet Loss Check = >> %logfile%
	@echo ============ Check Packet Loss to External ============ >> %logfile%
	ping -n 60 -f -4 %trace-svr-ext% >> %logfile%
	@echo ============ Check Packet Loss to Internal ============ >> %logfile%
	ping -n 60 -f -4 %iperf-svr% >> %logfile%




@echo.
@echo =======================================================
@echo = Step 4/4 ==================== Running Tracert Tests =
@echo =======================================================
	REM ## Reason this is here twice is so that it appears in the logs
	@echo = Step 4/4 ==================== Running Tracert Tests = >> %logfile%
	@echo. >> %logfile%
	@echo. >> %logfile%
	@echo ================= Tracert to External ================= >> %logfile%
	tracert %trace-svr-ext% >> %logfile%
	@echo. >> %logfile%
	@echo ================= Tracert to Internal ================= >> %logfile%
	tracert %iperf-svr% >> %logfile%
	@echo. >> %logfile%



@echo ==================== COMPLETE ========================= >> %logfile%
@echo.
@echo.
COLOR 2F
@echo =======================================================
@echo               Diagnostics Tests Completed    
@echo 
@echo 		    Please send the generated log file to 
@echo 				support@hostednetwork.com.au        
@echo 
@echo        Please hit any key to close this window        
@echo =======================================================
pause